% tel4.m
% fd, 05 novembre 2006. 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  probleme du central telephonique ; cas de trois points
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
hold off
xlabel ('') ;
x=[0;.1;1] ; y=x ; plot (x,y) ; hold off ; 
xa = -1 ; ya = -.8 ; xb = 1 ; yb = -.5 ;  xc = -.3 ; yc = 1 ; 
np = 3 ; 
noeud = zeros (2,np) ; 
noeud (1,1) = xa ;  noeud (2,1) = ya ; 
noeud (1,2) = xb ;  noeud (2,2) = yb ; 
noeud (1,3) = xc ;  noeud (2,3) = yc ; 
xmin = 1000 ; ymin = xmin ; xmax = -xmin ; ymax = xmax ; 
for j = 1 : np ; 
xmin = min ( xmin , noeud(1:1,j:j)) ; 
ymin = min ( ymin , noeud(2:2,j:j)) ; 
xmax = max ( xmax , noeud(1:1,j:j)) ; 
ymax = max ( ymax , noeud(2:2,j:j)) ; 
end ; deltax = xmax - xmin ;  deltay = ymax - ymin ; 
xmin = xmin - .1*deltax ;  xmax = xmax + .1*deltax ; 
ymin = ymin - .1*deltay ;  ymax = ymax + .1*deltay ; 
axis ( [ xmin xmax ymin ymax ]  , 'square' ) ;
hold off 
plot ( [xa  xb xc ] , [ya  yb yc ] , '*;;') 
hold on ; 
n=arc(xa,ya,xb,yb) ; 
n=arc(xb,yb,xc,yc) ; 
n=arc(xc,yc,xa,ya) ; 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%        pb de minimisation 
x0 = 1 ; y0 = 1 ; 
plot ( x0 , y0 , '*m;;') 
x = x0 ; y = y0 ; 

for k = 1:35 ; 
gx = 0 ; gy = 0 ; 
for j = 1:np  ; 
apx = x - noeud(1:1,j:j)  ; 
apy = y - noeud(2:2,j:j) ; ap = sqrt(apx**2+apy**2) ; 
gx = gx + apx / ap ; gy = gy + apy / ap ; 
end 
ro = .2 ; 
xn = x - ro*gx ; yn = y - ro*gy ; 
plot ( xn , yn , '*m;;' , [x xn] , [y yn] , 'm;;') 
x=xn ; y = yn ; 
end ; 
scale = .1 ; n=100; 
for k = 1:3 ; pause ; 
xmin = xn - scale ; ymin = yn - scale ;  
xmax = xn + scale ; ymax = yn + scale ;  
axis ( [ xmin xmax ymin ymax ]  , 'square' ) ;
m=arc2(xa,ya,xb,yb,n) ; 
m=arc2(xb,yb,xc,yc,n) ; 
m=arc2(xc,yc,xa,ya,n) ; 
scale = scale/10 ; n = 10*n ; end ; 
format long 
xn , yn 